"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeGestureHandler = require("react-native-gesture-handler");

var _reactNativeReanimated = require("react-native-reanimated");

var _ViewGestureHandlerRootHOC = _interopRequireDefault(require("./ViewGestureHandlerRootHOC"));

var _reactNative = require("react-native");

var _ThumbnailComponent = _interopRequireDefault(require("./ThumbnailComponent"));

var _styles = require("./styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const SimpleImageView = _ref => {
  var _nowImage$title, _ref3;

  let {
    imageUri,
    bgColor,
    images,
    viewMode,
    selectedIndex,
    perPage,
    itemMargin,
    showTitle,
    complementaryBgColor,
    showPage
  } = _ref;

  const DeviceWidth = _reactNative.Dimensions.get('window').width;

  const imageSize = (perPage < 4 ? Math.round(DeviceWidth / 4) : Math.round(DeviceWidth / perPage)) - itemMargin;
  const imageBorderRadius = imageSize * 0.05;
  const tmpImgObj = {
    uri: '',
    title: ''
  };
  const [nowImage, setNowImage] = (0, _react.useState)(tmpImgObj);
  const [totPage, setToTPage] = (0, _react.useState)(undefined);
  const [imgIndex, setImgIndex] = (0, _react.useState)(0);
  const [imgArray, setImgArray] = (0, _react.useState)([]);
  const [nowPage, setNowPage] = (0, _react.useState)(1);
  const startX = (0, _reactNativeReanimated.useSharedValue)(0);
  const transX = (0, _reactNativeReanimated.useSharedValue)(0);
  const startY = (0, _reactNativeReanimated.useSharedValue)(0);
  const transY = (0, _reactNativeReanimated.useSharedValue)(0);
  const scaleXY = (0, _reactNativeReanimated.useSharedValue)(1);
  const savedScale = (0, _reactNativeReanimated.useSharedValue)(1);
  const rotation = (0, _reactNativeReanimated.useSharedValue)(0);
  const savedRotation = (0, _reactNativeReanimated.useSharedValue)(0);
  (0, _react.useEffect)(() => {
    if (viewMode === 'multi' && images && (images === null || images === void 0 ? void 0 : images.length) > 0) {
      var _images;

      setToTPage(Math.ceil((images === null || images === void 0 ? void 0 : images.length) / perPage));
      setNowImage((_images = images[selectedIndex]) !== null && _images !== void 0 ? _images : imageUri);
    } else {
      setToTPage(1);
      setNowImage(imageUri);
    }
  }, [images, imageUri]);
  (0, _react.useEffect)(() => {
    if (totPage && totPage > 0 && images && (images === null || images === void 0 ? void 0 : images.length) > 0) {
      const newArray = [];
      Array.from({
        length: totPage
      }).forEach((_, index) => {
        newArray.push(images === null || images === void 0 ? void 0 : images.slice(perPage * index, perPage * index + perPage));
      });
      setImgArray(newArray);
    }
  }, [totPage]);
  (0, _react.useEffect)(() => {
    if (!imgArray) return;
    setNowImage(tmpImgObj);
    setNowImage(images[imgIndex]);
  }, [imgIndex]);
  const transXYStyle = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    return {
      transform: [{
        translateX: transX.value
      }, {
        translateY: transY.value
      }, {
        scale: scaleXY.value
      }, {
        rotateZ: `${rotation.value / Math.PI * 180}deg`
      }]
    };
  }, []);

  const scaleAnimation = () => {
    'worklet';

    (0, _reactNativeReanimated.cancelAnimation)(scaleXY);
    (0, _reactNativeReanimated.cancelAnimation)(startX);
    (0, _reactNativeReanimated.cancelAnimation)(startY);
    savedScale.value = 1;
    startX.value = 0;
    startY.value = 0;
    scaleXY.value = (0, _reactNativeReanimated.withSpring)(1);
    transX.value = (0, _reactNativeReanimated.withSpring)(0);
    transY.value = (0, _reactNativeReanimated.withSpring)(0);
    rotation.value = (0, _reactNativeReanimated.withSpring)(0);
    savedRotation.value = 0;
  };

  const panHandler = _reactNativeGestureHandler.Gesture.Pan().maxPointers(1).onStart(() => {
    transX.value = startX.value;
    transY.value = startY.value;
  }).onUpdate(event => {
    transX.value = event.translationX + startX.value;
    transY.value = event.translationY + startY.value;
  }).onEnd(() => {
    startX.value = transX.value;
    startY.value = transY.value;
  });

  const pinchHandler = _reactNativeGestureHandler.Gesture.Pinch().onUpdate(e => {
    scaleXY.value = savedScale.value * (e.scale > 0 ? e.scale : 1);
  }).onEnd(() => {
    savedScale.value = scaleXY.value > 0 ? scaleXY.value : 1;
  });

  const tapHandler = _reactNativeGestureHandler.Gesture.Tap().numberOfTaps(2).maxDelay(300).onEnd(scaleAnimation);

  const rotateHandler = _reactNativeGestureHandler.Gesture.Rotation().onUpdate(e => {
    rotation.value = savedRotation.value + e.rotation;
  }).onEnd(() => {
    savedRotation.value = rotation.value;
  });

  const simultaneousHandler = _reactNativeGestureHandler.Gesture.Simultaneous(panHandler, pinchHandler, tapHandler, rotateHandler);

  const updateNowImageIndex = (pageIndex, imageIndex) => {
    setImgIndex(pageIndex * perPage + imageIndex);
  };

  const updateNowPage = (0, _react.useCallback)(e => {
    var _Math$floor, _e$nativeEvent, _e$nativeEvent$conten, _e$nativeEvent2, _e$nativeEvent2$layou;

    setNowPage(((_Math$floor = Math.floor((e === null || e === void 0 ? void 0 : (_e$nativeEvent = e.nativeEvent) === null || _e$nativeEvent === void 0 ? void 0 : (_e$nativeEvent$conten = _e$nativeEvent.contentOffset) === null || _e$nativeEvent$conten === void 0 ? void 0 : _e$nativeEvent$conten.x) / (e === null || e === void 0 ? void 0 : (_e$nativeEvent2 = e.nativeEvent) === null || _e$nativeEvent2 === void 0 ? void 0 : (_e$nativeEvent2$layou = _e$nativeEvent2.layoutMeasurement) === null || _e$nativeEvent2$layou === void 0 ? void 0 : _e$nativeEvent2$layou.width))) !== null && _Math$floor !== void 0 ? _Math$floor : 0) + 1);
  }, []);

  const keyExtractor = (_, index) => index.toString();

  const _renderItem = _ref2 => {
    let {
      item,
      index
    } = _ref2;
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: [_styles.styles.itemContainer, {
        width: DeviceWidth,
        backgroundColor: bgColor
      }]
    }, item === null || item === void 0 ? void 0 : item.map((el, imageIndex) => {
      return /*#__PURE__*/_react.default.createElement(_ThumbnailComponent.default, {
        key: index + ':' + imageIndex,
        nowPage: index,
        imgIndex: imageIndex,
        imgObj: el,
        imageBorderRadius: imageBorderRadius,
        imageSize: imageSize,
        perPage: perPage,
        borderColor: complementaryBgColor,
        updateNowImageIndex: updateNowImageIndex
      });
    }));
  };

  return images && (imageUri !== null && imageUri !== void 0 && imageUri.uri || (images === null || images === void 0 ? void 0 : images.length) > 0) ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flex: 1,
      backgroundColor: bgColor
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flex: 0.65,
      justifyContent: 'flex-end',
      alignItems: 'center'
    }
  }, showTitle && nowImage !== null && nowImage !== void 0 && nowImage.title && (nowImage === null || nowImage === void 0 ? void 0 : (_nowImage$title = nowImage.title) === null || _nowImage$title === void 0 ? void 0 : _nowImage$title.length) > 0 ? /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: {
      fontSize: 16,
      color: complementaryBgColor
    }
  }, `${nowImage === null || nowImage === void 0 ? void 0 : nowImage.title}`) : null), nowImage && nowImage !== null && nowImage !== void 0 && nowImage.uri ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flex: 4
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.GestureDetector, {
    gesture: simultaneousHandler
  }, /*#__PURE__*/_react.default.createElement(_ViewGestureHandlerRootHOC.default, {
    imageUri: nowImage,
    transXYStyle: transXYStyle,
    bgColor: bgColor
  }))) : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flex: 4,
      justifyContent: 'center',
      alignItems: 'center'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
    size: 'small',
    color: (_ref3 = complementaryBgColor) !== null && _ref3 !== void 0 ? _ref3 : '#FFFFFF'
  })), viewMode === 'multi' && totPage && totPage > 0 && imgArray && (imgArray === null || imgArray === void 0 ? void 0 : imgArray.length) > 0 ? /*#__PURE__*/_react.default.createElement(_reactNative.FlatList, {
    ListEmptyComponent: /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
      size: 'large',
      color: complementaryBgColor
    }),
    style: {
      flex: 0.85
    },
    windowSize: 1,
    initialNumToRender: totPage ? totPage >= 2 ? 2 : totPage : undefined,
    keyExtractor: keyExtractor,
    data: imgArray,
    renderItem: _renderItem,
    horizontal: true,
    pagingEnabled: true,
    removeClippedSubviews: true,
    showsVerticalScrollIndicator: false,
    showsHorizontalScrollIndicator: false,
    onMomentumScrollBegin: undefined,
    onMomentumScrollEnd: updateNowPage,
    onEndReached: undefined,
    onEndReachedThreshold: 0.5
  }) : null, viewMode === 'multi' && showPage ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      flex: 0.5,
      justifyContent: 'flex-start',
      alignItems: 'center'
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: {
      color: complementaryBgColor,
      fontSize: 15,
      fontWeight: '500'
    }
  }, `${nowPage} / ${totPage}`)) : null) : null;
};

var _default = SimpleImageView;
exports.default = _default;
//# sourceMappingURL=SimpleImageView.js.map