"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getComplementaryColor = void 0;

const getComplementaryColor = function () {
  let color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  let colorPart = color;

  if (color && color.startsWith('#')) {
    colorPart = color.slice(1);
  }

  const ind = parseInt(colorPart, 16);
  let iter = ((1 << 4 * colorPart.length) - 1 - ind).toString(16);

  while (iter.length < colorPart.length) {
    iter = '0' + iter;
  }

  return '#' + iter;
};

exports.getComplementaryColor = getComplementaryColor;
//# sourceMappingURL=Utils.js.map