"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeGestureHandler = require("react-native-gesture-handler");

var _reactNativeReanimated = _interopRequireDefault(require("react-native-reanimated"));

var _ErrorComponent = _interopRequireDefault(require("./ErrorComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ViewGestureHandlerRootHOC = (0, _reactNativeGestureHandler.gestureHandlerRootHOC)(_ref => {
  let {
    imageUri,
    bgColor,
    transXYStyle
  } = _ref;
  const [isError, setIsError] = (0, _react.useState)(false);

  const onImageLoadedHandler = e => {
    var _e$nativeEvent, _e$nativeEvent$source;

    if (isError && (e === null || e === void 0 ? void 0 : (_e$nativeEvent = e.nativeEvent) === null || _e$nativeEvent === void 0 ? void 0 : (_e$nativeEvent$source = _e$nativeEvent.source) === null || _e$nativeEvent$source === void 0 ? void 0 : _e$nativeEvent$source.width) >= 0) {
      setIsError(false);
    }
  };

  const onImageErrorHandler = () => {
    setIsError(true);
  };

  return imageUri ? /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: {
      flex: 1,
      backgroundColor: bgColor
    }
  }, isError ? /*#__PURE__*/_react.default.createElement(_ErrorComponent.default, {
    transXYStyle: transXYStyle,
    size: 'big'
  }) : /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.Image, {
    onLoad: onImageLoadedHandler,
    onError: onImageErrorHandler,
    style: [transXYStyle, {
      flex: 1
    }],
    source: {
      uri: imageUri === null || imageUri === void 0 ? void 0 : imageUri.uri
    },
    resizeMode: 'contain'
  })) : null;
});
var _default = ViewGestureHandlerRootHOC;
exports.default = _default;
//# sourceMappingURL=ViewGestureHandlerRootHOC.js.map